package com.liang.service;

import com.liang.entity.BasePerson;
import com.liang.entity.PrjMember;
import com.liang.entity.PrjProject;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 项目人员(PrjMember)表服务接口
 *
 * @author makejava
 * @since 2023-03-10 11:21:54
 */
public interface PrjMemberService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjMember queryById(Integer id);

    /**
     * 通过人员姓名和项目id查询单条数据
     *
     * @return 实例对象
     */
    PrjMember queryByRyAndXm(String ryxm, Integer xm);

    /**
     * 分页查询
     *
     * @param prjMember   筛选条件
     * @param pageRequest 分页对象
     * @return 查询结果
     */
    Page<PrjMember> queryByPage(PrjMember prjMember, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjMember 实例对象
     * @return 实例对象
     */
    int insert(PrjMember prjMember);

    /**
     * 修改数据
     *
     * @param prjMember 实例对象
     * @return 实例对象
     */
    PrjMember update(PrjMember prjMember);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 通过项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 获取项目人员
     *
     * @param map
     * @return
     */
    List<PrjMember> getMemberList(Map map);

    /**
     * 获取项目人员信息
     *
     * @param xm
     * @return
     */
    List<PrjMember> getMemberInfoList(Integer xm);

    /**
     * 批量插入项目人员
     *
     * @param memberList
     * @return
     */
    int insertBatch(List<PrjMember> memberList);

    /**
     * 批量删除项目人员
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);
}
